using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.InputSystem;


public class PlayerMove : MonoBehaviour
{
    [SerializeField] private Transform lookTarget = null;

    CharacterController characterController;
    PlayerInput playerInput;
    Animator animator;
    Camera mainCamera;

    // ړx
    private float walkSpeed = 2f;
    private float sprintSpeedUpRatio = 4f;
    private float rotationSpeed = 720f;

    bool isRunning = false;
    Vector2 input = Vector2.zero;

    void Start()
    {
        characterController = GetComponent<CharacterController>();
        playerInput = GetComponent<PlayerInput>();
        animator = GetComponent<Animator>();
        mainCamera = FindObjectOfType<Camera>();
    }

    void Update()
    {
        var velocity = Vector3.zero;

        // L[̓͂ǍɃLN^[]
        if (input.magnitude != 0)
        {
            Vector3 playerDirection = Vector3.Normalize(new Vector3(input.x, 0, input.y));
            Vector3 cameraDirection = lookTarget.position - mainCamera.transform.position;
            cameraDirection.y = 0;
            cameraDirection.Normalize();

            // J̌ɁAXeBbŇ|킹ALN^[XeBbN̕Ɍ
            Quaternion characterTargetRotation = Quaternion.LookRotation(cameraDirection) * Quaternion.LookRotation(playerDirection);
            transform.rotation = Quaternion.RotateTowards(transform.rotation, characterTargetRotation, rotationSpeed * Time.deltaTime);
        }

        // ړx̌vZ
        float speedByStick = input.magnitude;
        float moveSpeed = walkSpeed * speedByStick;

        if (isRunning)
        {
            moveSpeed *= sprintSpeedUpRatio;
        }
        velocity = transform.forward * moveSpeed;

        // Aj[V̑xݒ
        animator.SetFloat("Speed", moveSpeed);

        // LN^[̈ړ
        characterController.Move(velocity * Time.deltaTime);

        Debug.Log("isRunnging : " + isRunning.ToString());
    }

    public void OnMove(InputValue value)
    {
        input = value.Get<Vector2>();
    }
    public void OnSprint(InputValue value)
    {
        isRunning = value.isPressed;
    }

}
